;*********************************************************
;   PIC16F84    DS1821 
; ..  2001.
;********************************************************* 

	__CONFIG _CP_OFF & _WDT_OFF & _XT_OSC

 ; 16F84                DS1821 ( PR35)
 ; PORTB, Bit 4 --------DQ ( 1)
 ; PORTB, Bit 0 --------DQ ( 2)

       LIST p=16F84
#include <p16f84.inc>

;   PIC16C84,   
; #include <p1684.inc>

        constant DATA_PIN=4     ;   
        constant DATA_PIN2=0	;  DS1821
;-------------------------------------------
        CBLOCK  0CH

        T_C             ;     1
	T_C2		;     2
        _N              ;    
        O_BYTE          ;     1
        I_BYTE          ;     1
        O_BYTE2         ;     2
        I_BYTE2         ;     2
        LOOP3		;              
        LOOP2           ;
        LOOP1         	;  
        TEMP		;
	TEMP2 		;
	LCDINFO		;    
	DISPDATA	;    
	LCDTIME		;   
        LSD		;     1
        MSD		;     1
	LSD2		;     2
	MSD2		;     2
        SIGN1           ;    1 
        SIGN2           ;    2 

        ENDC
;-------------------------------------------
;       161
;-------------------------------------------
LCDDATA	equ	PORTA	; i/o RA0-RA3 = 4-bit  
LCDCTRL	equ	PORTB	;  
DISP_E  equ     1       ;  /
DISP_RW equ     2       ; / 
DISP_RS equ     3       ;   
BF_FLAG	equ	1	;   
I_FLAG	equ	2	;   (/)

;********************************************
;	
;********************************************
PORTALO	macro
	bsf     STATUS,RP0      ;   1  
	movlw   b'11100000'     ;    
	movwf   TRISA           ; 
	bcf     STATUS,RP0      ;    0
	endm
;-------------------------------------------
PORTAHI	macro
	bsf     STATUS,RP0      ;   1  
	movlw   b'11101111'     ;    
	movwf   TRISA           ; 
	bcf     STATUS,RP0      ;    0
	endm
;-------------------------------------------
CLKDISP	macro
	bsf	LCDCTRL,DISP_E	;      1
	bcf	LCDCTRL,DISP_E	;      0
	endm
;-------------------------------------------
DISPCLR	macro
	movlw   b'00000001'     ;  
	call    SENDI           ;    
	endm
;-------------------------------------------
LINE1	macro
	movlw	b'10000000'	;    1- 
	call	SENDI		; 1- 
	endm			; 
;-------------------------------------------
LINE2	macro
	movlw	b'11000000'	;    1- 
	call	SENDI		; 2-  (   9 
	endm			;  )
;-------------------------------------------
LCDINIT	macro
	PORTALO			;     
	movlw   0xF0            ;  15    
	call    LCDWAIT		; 
	movlw   b'00000010'     ;  4-  
	movwf	LCDCTRL		;    
	CLKDISP		        ;    
	movlw   d'5'            ;  5 
	call    LCDWAIT		; 
	movlw   b'00101000'     ;  4-   2- 
	call    SENDI           ; 
	movlw   b'00101000'     ;  4-   2- 
	call    SENDI           ; 
	movlw   b'00001000'     ;  
	call    SENDI           ; 
	DISPCLR
	movlw   b'00001100'     ;  
	call    SENDI           ; 
	movlw   b'00000110'     ;     
	call    SENDI           ; 
	movlw	40		;   
	call	SENDI		;   0
	movlw	1C
	call	SENDD
	movlw	14
	call	SENDD
	movlw	1C
	call	SENDD
	clrw
	call	SENDD
	clrw
	call	SENDD
	clrw
	call	SENDD
	clrw
	call	SENDD
	clrw
	call	SENDD
	movlw	80
	call	SENDI
	endm

;******************************************************
;  
;******************************************************
        ORG 000H
        goto MAIN
        org     4
        goto    int
MAIN:
        clrf	PORTA		;   
	clrf	PORTB		;   
	bsf	STATUS,RP0	;  1 
	bcf	OPTION_REG,NOT_RBPU ;  
	movlw	b'11100000'	;     
	movwf	TRISA		; 
	movlw	b'11000001'	;     
	movwf	TRISB
	bcf	STATUS,RP0	;    2 
        LCDINIT			;  
        CALL 	CONFIG_DEVICE   ;   1
        CALL 	CONFIG_DEVICE2  ;   2
MAIN_1:
        CALL 	START_CONVERT   ;    1
        CALL 	READ_TEMP       ;   1
        MOVWF 	T_C             ;     _
        CALL 	STOP_CONVERT    ;    1
	btfsc	T_C,7		;   
	goto	minus		;   7=1,   "-"
plus	movlw	'+'		;   "+"
	movwf	SIGN1		;  "+"  
disp    CALL 	DISPLAY         ;    
        movlw   4               ;  1 
        MOVWF 	LOOP3
MAIN_2:
        CALL 	DELAY_LONG
        DECFSZ 	LOOP3, F
        GOTO 	MAIN_2
;-----------------------------------------------
;       
;-----------------------------------------------
MAIN_3:
        CALL 	START_CONVERT2
        CALL 	READ_TEMP2
        MOVWF 	T_C2
        CALL 	STOP_CONVERT2
	btfsc	T_C2,7
	goto	minus2
plus2	movlw	'+'
	movwf	SIGN2
disp2	CALL 	Display2
	movlw   4
        MOVWF 	LOOP3
MAIN_4:
        CALL 	DELAY_LONG
        DECFSZ 	LOOP3, F
        GOTO 	MAIN_4
        GOTO 	MAIN_1		;   1- 
;-----------------------------------------
minus	movlw	'-'		;  "-"
	movwf	SIGN1		;  
	movf	T_C,w		;  
	sublw	0FF		;   -
	addlw	1		;    
	movwf	T_C		;  
	goto	disp

minus2	movlw	'-'		;    2- 
	movwf	SIGN2
	movf	T_C2,w
	sublw	0FF
	addlw	1
	movwf	T_C2
	goto	disp2
;----------------------------------------
CONFIG_DEVICE:
        CALL 	INIT
        MOVLW 	0CH
        MOVWF 	O_BYTE
        CALL 	OUT_BYTE
        MOVLW 	03H             ;  ,   1
        MOVWF 	O_BYTE
        CALL 	OUT_BYTE
        MOVLW 	.20             ;  20    
        MOVWF 	LOOP1
        CALL 	DELAY_N_MS
        RETURN

CONFIG_DEVICE2:			;     1
        CALL 	INIT2
        MOVLW 	0CH
        MOVWF 	O_BYTE2
        CALL 	OUT_BYTE2
        MOVLW 	03H 
        MOVWF 	O_BYTE2
        CALL 	OUT_BYTE2
        MOVLW 	.20 
        MOVWF 	LOOP1
        CALL 	DELAY_N_MS
        RETURN
;---------------------------------------

START_CONVERT:
        CALL 	INIT
        MOVLW 	0EEH
        MOVWF 	O_BYTE
        CALL 	OUT_BYTE
        MOVLW 	.100            ;  100 
        MOVWF 	LOOP1
        CALL 	DELAY_N_MS
        RETURN

START_CONVERT2:
        CALL 	INIT2
        MOVLW 	0EEH
        MOVWF 	O_BYTE2
        CALL 	OUT_BYTE2
        MOVLW 	.100
        MOVWF 	LOOP1
        CALL 	DELAY_N_MS
        RETURN
;---------------------------------------
READ_TEMP:
        CALL 	INIT
        MOVLW 	0AAH
        MOVWF 	O_BYTE
        CALL 	OUT_BYTE
        CALL 	IN_BYTE
        MOVF 	I_BYTE, W
        RETURN

READ_TEMP2:
        CALL 	INIT2
        MOVLW 	0AAH
        MOVWF 	O_BYTE2
        CALL 	OUT_BYTE2
        CALL 	IN_BYTE2
        MOVF 	I_BYTE2, W
        RETURN
;---------------------------------------
STOP_CONVERT:
        CALL 	INIT
        MOVLW 	22H
        MOVWF 	O_BYTE
        CALL 	OUT_BYTE
        RETURN

STOP_CONVERT2:
        CALL 	INIT2
        MOVLW 	22H
        MOVWF 	O_BYTE2
        CALL 	OUT_BYTE2
        RETURN
;---------------------------------------
DISPLAY:
	LINE1
	movlw	055		; "U"
	call	SENDD
	movlw	04C		; "L"
	call	SENDD
	movlw	049		; "I"
	call	SENDD
        movlw	043		; "C"
	call	SENDD
        movlw	041		; "A"
	call	SENDD
	movlw	' '		; 
	call	SENDD
	movf	SIGN1,w	;  "+"  "-"
	call	SENDD
	movf	T_C,w
	call 	BINBCD	;    
	movf	MSD,W		;   
	addlw	30
	call	SENDD
	movf	LSD,W		;   
	addlw	30
	call	SENDD
	movlw	0		;   
	call	SENDD
	movlw	' '		; 
	call	SENDD
	return

Display2
	LINE2
	movlw	053		; "S"
	call	SENDD
	movlw	041		; "A"
	call	SENDD
	movlw	04C		; "L"
	call	SENDD
        movlw	04F		; "O"
	call	SENDD
        movlw	04E		; "N"
	call	SENDD
	movlw	' '		; 
	call	SENDD
	movf	SIGN2,w
	call	SENDD
	movf	T_C2,w
	call	BINBCD2
	movf	MSD2,W
	addlw	30
	call	SENDD
	movf	LSD2,W
	addlw	30
	call	SENDD
	movlw	0		;   
	call	SENDD	
        return

;-------------------------------------------
;     1-Wire
;-------------------------------------------
INIT:
        CALL    PIN_HI
        CALL    PIN_LO
        MOVLW   .50              ;  500 
        CALL 	DELAY_10USEC
        CALL    PIN_HI
        MOVLW   .50              ;  500 
        CALL 	DELAY_10USEC
        RETURN

INIT2:
        CALL    PIN_HI2
        CALL    PIN_LO2
        MOVLW   .50              ;  500 
        CALL 	DELAY_10USEC
        CALL    PIN_HI2
        MOVLW   .50              ;  500 
        CALL 	DELAY_10USEC
        RETURN
;-------------------------------------------
WAIT:
        CALL    IN_BYTE
        MOVLW   0FFH
        SUBWF   I_BYTE, W
        BTFSS   STATUS, Z
        GOTO    WAIT
        RETURN

WAIT2:
        CALL    IN_BYTE2
        MOVLW   0FFH
        SUBWF   I_BYTE2, W
        BTFSS   STATUS, Z
        GOTO    WAIT2
        RETURN
;-------------------------------------------
IN_BYTE:              		;    W 
        MOVLW   .8
        MOVWF    _N
        CLRF    I_BYTE
IN_BYTE_1:
        CALL 	PIN_LO
        NOP
        CALL 	PIN_HI
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        MOVF    PORTB, W        ; 7 usecs later, fetch from DATA_PIN
        MOVWF   TEMP
        BTFSS   TEMP, DATA_PIN
        BCF 	STATUS, C       ; its a zero
        BTFSC   TEMP, DATA_PIN
        BSF 	STATUS, C       ; its a one
        RRF     I_BYTE, F
        MOVLW 	.6              ; now delay 60 usecs
        CALL    DELAY_10USEC
        DECFSZ  _N, F
        GOTO    IN_BYTE_1
        MOVFW   I_BYTE          ; return the result in W
        RETURN

IN_BYTE2:              		; returns byte in W
        MOVLW   .8
        MOVWF    _N
        CLRF    I_BYTE2
IN_BYTE_12:
        CALL 	PIN_LO2         ; momentary low on DATA_PIN
        NOP
        CALL 	PIN_HI2
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        MOVF    PORTB, W        ; 7 usecs later, fetch from DATA_PIN
        MOVWF   TEMP2
        BTFSS   TEMP2, DATA_PIN2
        BCF 	STATUS, C       ; its a zero
        BTFSC   TEMP2, DATA_PIN2
        BSF 	STATUS, C       ; its a one
        RRF     I_BYTE2, F
        MOVLW 	.6              ; now delay 60 usecs
        CALL    DELAY_10USEC
        DECFSZ  _N, F
        GOTO    IN_BYTE_12
        MOVFW   I_BYTE2          ; return the result in W
        RETURN
;------------------------------------------
OUT_BYTE:
        MOVLW   .8
        MOVWF   _N
OUT_BYTE_1:
        RRF     O_BYTE, F
        BTFSS   STATUS, C
        GOTO    OUT_0
        GOTO    OUT_1
OUT_BYTE_2:
        DECFSZ  _N, F
        GOTO    OUT_BYTE_1
        RETURN

OUT_BYTE2:
        MOVLW   .8
        MOVWF   _N
OUT_BYTE_12:
        RRF     O_BYTE2, F
        BTFSS   STATUS, C
        GOTO    OUT_02
        GOTO    OUT_12
OUT_BYTE_22:
        DECFSZ  _N, F
        GOTO    OUT_BYTE_12
        RETURN
;-------------------------------------------
OUT_0:
        CALL    PIN_LO          ; bring DATA_PIN low
        MOVLW   .6              ; for 60 usecs
        CALL    DELAY_10USEC
        CALL    PIN_HI
        GOTO    OUT_BYTE_2
OUT_1:
        CALL    PIN_LO          ; momentary low
        CALL    PIN_HI
        MOVLW 	.6
        CALL 	DELAY_10USEC
        GOTO    OUT_BYTE_2

;-----------------------------------------

PIN_HI:
        BSF     STATUS, RP0
        BSF     TRISB, DATA_PIN ; high impedance
        BCF     STATUS, RP0
        RETURN
OUT_02:
        CALL    PIN_LO2          ; bring DATA_PIN low
        MOVLW   .6               ; for 60 usecs
        CALL    DELAY_10USEC
        CALL    PIN_HI2
        GOTO    OUT_BYTE_22
OUT_12:
        CALL    PIN_LO2          ; momentary low
        CALL    PIN_HI2
        MOVLW 	.6
        CALL 	DELAY_10USEC
        GOTO    OUT_BYTE_22

;---------------------------------------

PIN_HI2:
        BSF     STATUS, RP0
        BSF     TRISB, DATA_PIN2  ; high impedance
        BCF     STATUS, RP0
        RETURN
;---------------------------------------
PIN_LO:
        BCF     PORTB, DATA_PIN
        BSF     STATUS, RP0
        BCF     TRISB, DATA_PIN    ; low impedance zero
        BCF     STATUS, RP0
        RETURN
PIN_LO2:
        BCF     PORTB, DATA_PIN2
        BSF     STATUS, RP0
        BCF     TRISB, DATA_PIN2    ; low impedance zero
        BCF     STATUS, RP0
        RETURN
;---------------------------------------
DELAY_LONG
        MOVLW 	.250      ;  250 
        MOVWF 	LOOP1
DELAY_N_MS:
OUTTER:
        MOVLW   .110      ;  1 
        MOVWF   LOOP2
INNER:
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        DECFSZ  LOOP2, F
        GOTO 	INNER
        DECFSZ  LOOP1, F
        GOTO 	OUTTER
        RETURN
;---------------------------------------
DELAY_10USEC:   	;   W * 10 
        MOVWF 	LOOP1
DELAY_10USEC_1:
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        DECFSZ 	LOOP1, F
        GOTO 	DELAY_10USEC_1
        RETURN
;********************************************
;     
;********************************************
SENDI:
	bsf	LCDINFO,I_FLAG	; Next data is an instruction
SENDD:
	movwf   DISPDATA        ; Store send-data for later use
	PORTAHI			; Put PortA tristate
	bcf	LCDCTRL,DISP_RS	; RS=0 => Instruction
	bsf	LCDCTRL,DISP_RW	; RW=1 => Read
DISPBUSY:
	bsf	LCDCTRL,DISP_E	; Display puts data on LCDDATA
	bcf     LCDINFO,BF_FLAG	; Busy flag is probably = 0
	btfsc   PORTA,3         ; Read busy flag from display
	bsf     LCDINFO,BF_FLAG	; Busy flag was = 1
	bcf	LCDCTRL,DISP_E	; Lower display enable port
	CLKDISP			; Clock out the last and uninteresting nibble
	btfsc   LCDINFO,BF_FLAG ; Check if display is ready
	goto    DISPBUSY        ; The display is not ready
	PORTALO			; Put portA in a low impedance state
	bsf	LCDCTRL,DISP_RS	; RS=1 => Data
	bcf	LCDCTRL,DISP_RW	; RW=0 => Write
	btfsc   LCDINFO,I_FLAG	; Check if SENDData?
	bcf	LCDCTRL,DISP_RS	; No, RS=0 => Instruction
	swapf   DISPDATA,W      ; Put first nibble to send in W-low
	movwf   LCDDATA		; Put first nibble to portA
	CLKDISP			; Clock out the first nibble to display
	movf    DISPDATA,W      ; Put last nibble to send in W
	movwf	LCDDATA		; Put last nibble on portA
	CLKDISP			; Clock out the last nibble to display
	bcf     LCDINFO,I_FLAG	; Assume next send is SENDD
	return
;----------------------------------------
LCDWAIT:
	clrf	LCDTIME		; Clear time downcounter
LCDWAITLOOP:
	nop			; Extend timerloop to 256
	decfsz	LCDTIME,F	; Decrement timer
	goto	LCDWAITLOOP	; and loop if not down to zero again
	movwf	LCDTIME		; W contains outer loop value
	decfsz	LCDTIME,W	; Decrement
	goto	LCDWAIT
	return
;-------------------------------------
BINBCD:	
	CLRF 	MSD
	MOVF	T_C,w
	MOVWF	LSD
GTENTH:
	movlw	d'10'
	subwf	LSD,W
	btfss	STATUS,C
	goto	OVER
	movwf	LSD
	incf	MSD,F
	goto	GTENTH
OVER:	retlw	0

BINBCD2:	
	CLRF 	MSD2
	MOVF	T_C2,w
	MOVWF	LSD2
GTENTH2:
	movlw	d'10'
	subwf	LSD2,W
	btfss	STATUS,C
	goto	OVER2
	movwf	LSD2
	incf	MSD2,F
	goto	GTENTH2
OVER2:	retlw	0
;------------------------------------
int:    retfie
;*************************************************
        END


